#include "Customer.h"
#include "Account.h"
#include "Reader.h"
#include "Writer.h"
#include "List.h"



void Customer::acceptReader(Reader* reader)
{
	firstName = reader->readString();
	lastName = reader->readString();
	middleInitial = reader->readChar();
	accounts = reader->readList();
}

void Customer::acceptWriter(Writer* writer) const
{
	writer->writeString(firstName);
	writer->writeString(lastName);
	writer->writeChar(middleInitial);
	writer->writeList(accounts);
}

const char* Customer::typeName() const
{
	return "Customer";
}

void Customer::addAccount(Account* account)
{
	accounts->append(account);
}

void Customer::removeAccount(Account* account)
{
	accounts->remove(account);
}

Customer::Customer()
{
	accounts = new List;
}	

Customer::Customer(const String& first, const String& last) : firstName(first), lastName(last)
{
	accounts = new List;
}
