#ifndef _Iterator_h
#define _Iterator_h

#include "Types.h"



class List;
class Object;
class Cons;



class Iterator
{
public:
		// just do it! return current item and advance to next
	const Object* operator()();

		// return current item
	const Object* item();

		// insert and remove operation for manipulating the list
	void insert( const Object* );
	void remove();
	void remove( const Object* );

		// further retrieval functionality
	bool contains( const Object* );

		// connects and disconnects to specific lists
	void connect( const List& );
	void disconnect();

		// ctor and dtor
	Iterator( const List& );
	Iterator( const List* );
	~Iterator();

private:
		// implementation: holds a cons cell in a list
	List* pList;
	Cons* pCons;
};



#endif


