#include <ctype.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>



#include "String.h"



bool String::isSpace( char c ) const
{
	return isspace( c ) || iscntrl( c );
}


String String::word( int Num ) const
{
	int i = 0, j = 0;
	for ( ; Num > 0; Num -- )
	{
		for ( i = j; isSpace( s[ i ] && s[ i ] != '\0' ); i++ );
		for ( j = i; ! isSpace( s[ j ] ) && s[ j ] != '\0'; j++ );
	}

	return mid( i, j - i );
}


String String::mid( int left, int width ) const
{
	char* p = new char[ width + 1 ];
	strncpy ( p, s + left, width );
	p[ width ] = '\0';

	String str;
	str.s = p;
	return str;
}


String String::left( int width ) const
{
	return mid( 0, width );
}


String String::right( int width ) const
{
	return s + length() - width;
}


int String::length() const
{
	return ::strlen(s);
}


int String::strlen() const
{
	return ::strlen(s);
}


int String::asInt() const
{
	return atoi( s );
}


long String::asLong() const
{
	return atol( s );
}


char* String::charPtr() const
{
	return s;
}


ulong String::hash() const
{
	long hash = 0;
	for ( char* p = s; * p; p ++ ) hash += ( long ) *p;

	return hash;
}


String String::operator()( int index ) const
{
	return s + index;
}


bool String::operator==( const String& str ) const
{
	return strcmp( str.s, s ) == 0;
}


bool String::operator==( const char* p ) const
{
	return strcmp( p, s ) == 0;
}


bool String::operator!=( const String& str ) const
{
	return ! this->operator==( str );
}


bool String::operator!=( const char* p ) const
{
	return ! this->operator==( p );
}


void String::fromInt( int val )
{
	fromLong( ( long ) val );
}


void String::fromLong( long val )
{
	char sBuffer[16];
	sprintf(sBuffer, "%d", val);
	this->operator=(sBuffer);
}


void String::fromFloat( float val )
{
	fromDouble( ( double ) val );
}


void String::fromDouble( double val )
{
	char sBuffer[16];
	sprintf(sBuffer, "%d", val);
	this->operator=(sBuffer);
}


char String::operator[]( int index ) const
{
	return s[ index ];
}


String& String::operator=( const String& o )
{
	return this->operator=( o.s );
}


String& String::operator=( const char* p )
{
	delete[] s;
	s = new char[ ::strlen(p) + 1 ];
	strcpy( s, p );
	return *this;
}


String& String::operator+=( const String& o )
{
	return this->operator+=( o.s );
}


String& String::operator+=( const char* z )
{
	char* p = new char[ ::strlen( s ) + ::strlen( z ) + 1 ];
	strcpy ( p, s );
	strcat ( p, z );
	
	delete[] s;
	s = p;

	return *this;
}


String::String( const String& o )
{
	s = new char[ ::strlen(o.s) + 1 ];
	strcpy( s, o.s );
}


String::String( const char* p )
{
	s = new char[ ::strlen(p) + 1 ];
	strcpy (s, p);
}


String::String( char c )
{
	s = new char[ 2 ];
	s[ 0 ] = c;
	s[ 1 ] = '\0';
}

String::String(long l)
{
	s = 0;
	fromLong(l);
}

String::String(double d)
{
	s = 0;
	fromDouble(d);
}

String::String()
{
	s = new char[ 1 ];
	s[ 0 ] = '\0';
}


String::~String()
{
	delete[] s;
}


String operator+ ( String& f, String& s )
{
	return f + s.s;
}


String operator+ ( String& f, char* s )
{
	char* p = new char[ f.length() + strlen( s ) + 1 ];
	strcpy( p, f.s );
	strcat( p, s );

	String str;
	delete[] str.s;
	str.s = p;
	return str;
}


String operator+ ( char* f, String& s )
{
	char* p = new char[ strlen( f ) + s.length() ];
	strcpy ( p, f );
	strcat ( p, s.s );

	String str;
	delete[] str.s;
	str.s = p;
	return str;
}

